//
//  DynamicButton.h
//  DynamicUIButton
//
/*Copyright (c) 2012 Brandon McQuilkin
 
 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

//Button States
#define kDBStateInitial @"Inital"
#define kDBStateConfirm @"Confirm"
#define kDBStateProcess @"Process"
#define kDBStateSuccess @"Success"
#define kDBStateFailure @"Failure"
#define kDBStateDisabled @"Disabled"

//State Parameter Keys
#define kDBParameterTintKey @"Tint"
#define kDBParameterTitleKey @"Title"

//Animation Key and Types
#define kDBToggleStyleKey @"Toggle"
#define kDBToggleLeft @"Left"
#define kDBToggleRight @"Right"
#define kDBToggleCenter @"Center"

//Font Name Key
#define kDBFontNameKey @"Font"

//Icon Key
#define kDBIconKey @"Icon"

@interface DynamicButton : UIButton
{
    NSMutableDictionary *parametersDictionary;
    NSString *currentState;
    CALayer *colorLayer;
    CALayer *darkenLayer;
    UIButton *cancelOverlay;
}

- (id)initWithParameters:(NSDictionary *)parameters andFrame:(CGRect)frameTemplate;
- (void)disableWithDisabledStateParameters:(NSDictionary *)parameters;
- (void)changeButtonToState:(NSString *)state;

@end
